package de.ctdo.bunti.dao;

import java.util.ArrayList;
import java.util.List;

import de.ctdo.bunti.dmx.DMXChannel;
import de.ctdo.bunti.model.BuntiDMXDevice;
import de.ctdo.bunti.model.BuntiDevice;

public class BuntiDevicesDAOImpl implements BuntiDevicesDAO {
	
	List<BuntiDevice> devices = new ArrayList<BuntiDevice>();
	
	public BuntiDevicesDAOImpl() {
		addDummyDevices();
	}


	private void addDummyDevices() {
		BuntiDMXDevice d1 = new BuntiDMXDevice();
		d1.setDeviceID(1);
		d1.setDeviceName("Par65 Lampe 1");
		d1.setStartAddress(1);
		d1.addChannel(new DMXChannel(0, "mode"));
		d1.addChannel(new DMXChannel(1, "red"));
		d1.addChannel(new DMXChannel(2, "green"));
		d1.addChannel(new DMXChannel(3, "blue"));
		d1.addChannel(new DMXChannel(4, "speed"));
		devices.add(d1);
		
		d1 = new BuntiDMXDevice();
		d1.setDeviceID(6);
		d1.setDeviceName("Par65 Lampe 2");
		d1.setStartAddress(1);
		d1.addChannel(new DMXChannel(0, "mode"));
		d1.addChannel(new DMXChannel(1, "red"));
		d1.addChannel(new DMXChannel(2, "green"));
		d1.addChannel(new DMXChannel(3, "blue"));
		d1.addChannel(new DMXChannel(4, "speed"));
		devices.add(d1);
		
		d1 = new BuntiDMXDevice();
		d1.setDeviceID(11);
		d1.setDeviceName("Par65 Lampe 4");
		d1.setStartAddress(1);
		d1.addChannel(new DMXChannel(0, "mode"));
		d1.addChannel(new DMXChannel(1, "red"));
		d1.addChannel(new DMXChannel(2, "green"));
		d1.addChannel(new DMXChannel(3, "blue"));
		d1.addChannel(new DMXChannel(4, "speed"));
		devices.add(d1);
		
		d1 = new BuntiDMXDevice();
		d1.setDeviceID(16);
		d1.setDeviceName("Par65 Lampe 4");
		d1.setStartAddress(1);
		d1.addChannel(new DMXChannel(0, "mode"));
		d1.addChannel(new DMXChannel(1, "red"));
		d1.addChannel(new DMXChannel(2, "green"));
		d1.addChannel(new DMXChannel(3, "blue"));
		d1.addChannel(new DMXChannel(4, "speed"));
		devices.add(d1);
		
	}


	@Override
	public List<BuntiDMXDevice> getAllDMXDevices() {
		List<BuntiDMXDevice> liste = new ArrayList<BuntiDMXDevice>();
		for (BuntiDevice device : devices) {
			if( device.getClass().equals(BuntiDMXDevice.class) ) {
				liste.add((BuntiDMXDevice) device);
			}
		}
		return liste;
	}

}
